﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.IO;
using System.Reflection;
using Microsoft.SqlServer.TransactSql.ScriptDom;
using System.Data.SqlClient;

namespace AssemblyContents
{
    public static class AssemblyAnalyzer
    {
        public static void WriteAssemblyStructureToSQL()
        {
            SqlConnectionStringBuilder builder = new SqlConnectionStringBuilder();
            {
                builder.DataSource = "...";
                builder.InitialCatalog = "...";
                builder.IntegratedSecurity = true;

                using (SqlConnection conn = new SqlConnection(builder.ConnectionString))
                {
                    conn.Open();

                    using (SqlCommand cmd = new SqlCommand())
                    {
                        cmd.Connection = conn;
                        cmd.CommandType = System.Data.CommandType.Text;

                        cmd.CommandText = "truncate table dbo.ParserClassInfo;";
                        cmd.ExecuteNonQuery();
                    }
                }
            }

            Assembly asm = Assembly.GetAssembly(typeof(Microsoft.SqlServer.TransactSql.ScriptDom.CreateViewStatement));
            foreach (Type type in asm.GetTypes())
            {
                string classname = type.Name;
                string class_ns = type.Namespace;
                bool isAbstract = type.IsAbstract;
                string baseclassname = (type.BaseType == null ? null : type.BaseType.Name);
                string baseclass_ns = (type.BaseType == null ? null : type.BaseType.Namespace);
                char classtype = 'C';

                if (type.IsEnum)
                {
                    classtype = 'E';
                }
                else if (type.IsInterface)
                {
                    classtype = 'I';
                }
                else if (type.IsClass)
                {
                    classtype = 'C';
                }

                using (SqlConnection conn = new SqlConnection(builder.ConnectionString))
                {
                    conn.Open();

                    using (SqlCommand cmd = new SqlCommand())
                    {
                        cmd.Connection = conn;
                        cmd.CommandType = System.Data.CommandType.Text;

                        cmd.CommandText =
                            "insert into dbo.ParserClassInfo"
                            + "( [classname], [classtype], [isAbstract], [class_namespace], [baseclass], [baseclass_namespace] )"
                            + "  VALUES"
                            + " (@classname, @classtype, @isAbstract, @class_namespace, @baseclass, @baseclass_namespace);";
                        cmd.Parameters.Add(new SqlParameter("@classname", System.Data.SqlDbType.VarChar, 200)).Value = (object)classname ?? DBNull.Value;
                        cmd.Parameters.Add(new SqlParameter("@classtype", System.Data.SqlDbType.Char, 1)).Value = (object)classtype ?? DBNull.Value;
                        cmd.Parameters.Add(new SqlParameter("@isAbstract", System.Data.SqlDbType.Bit)).Value = (object)isAbstract;
                        cmd.Parameters.Add(new SqlParameter("@class_namespace", System.Data.SqlDbType.VarChar, 400)).Value = (object)class_ns ?? DBNull.Value;
                        cmd.Parameters.Add(new SqlParameter("@baseclass", System.Data.SqlDbType.VarChar, 200)).Value = (object)baseclassname ?? DBNull.Value;
                        cmd.Parameters.Add(new SqlParameter("@baseclass_namespace", System.Data.SqlDbType.VarChar, 400)).Value = (object)baseclass_ns ?? DBNull.Value;
                        cmd.ExecuteNonQuery();
                    }
                }
            }
        }
    }
}