﻿CREATE FUNCTION [dbo].[utvf_DescendantsOfThis]
(
	@classname varchar(200) = 'StatementWithCtesAndXmlNamespaces'
)
RETURNS 
@returntable TABLE 
(
	[id] int 
	, [classname] varchar(200) 
	, [isAbstract] bit 
	, [classnamehierarchy] varchar(max)
)
AS
BEGIN

	insert into @returntable 
	( [id], [classname], [isAbstract], [classnamehierarchy] ) 
	select 
		A.[id]
		, A.[classname]
		, [isAbstract]
		, [classnamehierarchy]
	from [dbo].[vw_ParserClassInfo] as A
	cross join ( 
		select [classhierarchy] 
		from [dbo].[vw_ParserClassInfo] 
		where classname = @classname 
	) B 
	where A.[classhierarchy].IsDescendantOf(B.[classhierarchy]) = 1 
	order by A.[classname];
	
	RETURN 
END
