﻿create procedure [dbo].[usp_ParserClassHierarchy]
as 
begin 

truncate table [dbo].[ParserClassHierarchy];

insert into [dbo].[ParserClassHierarchy]
( [id], [classhierarchy], [classnamehierarchy] ) 
SELECT 
	[id]
	, CAST(hierarchyid::GetRoot().ToString() + cast([id] as varchar(10)) + '/' AS hierarchyid) as classhierarchy 
	, '' as [classnamehierarchy]
FROM [dbo].[ParserClassInfo]
where 
	[classtype] = 'C' 
	and 
	( 
		[baseclass] is null 
		or 
		baseclass_namespace not in ( 
			select distinct [class_namespace] 
			from [dbo].[ParserClassInfo]
			where [class_namespace] is not null 
		) 
	); 

declare @thisround_classes TABLE 
( 
	[id] int
	, [baseclass] varchar(200)
	, [baseclass_namespace] varchar(400) 
);

insert into @thisround_classes
( 
	[id], [baseclass], [baseclass_namespace] 
) 
select [id], [baseclass], [baseclass_namespace] 
from [dbo].[ParserClassInfo] 
where 
	[classtype] = 'C' 
	and [id] not in ( select [id] from [dbo].[ParserClassHierarchy] );

while ( ( select count(*) from @thisround_classes ) > 0 )
begin 
	insert into [dbo].[ParserClassHierarchy]
	( [id], [classhierarchy], [classnamehierarchy] ) 
	select 
		A.[id]
		, CAST(B.classhierarchy.ToString() + cast(A.[id] as varchar(10)) + '/' as hierarchyid) as classhierarchy 
		, B.[classnamehierarchy] + '\' + A.[baseclass] as [classnamehierarchy]
	from @thisround_classes A 
	inner join ( 
		select C.*, D.classhierarchy, D.[classnamehierarchy] 
		from [dbo].[ParserClassInfo] C 
		inner join [dbo].[ParserClassHierarchy] D 
		on C.[id] = D.[id] 
	) B 
	on 
		A.[baseclass] = B.[classname]
		and A.[baseclass_namespace] = B.[class_namespace];

	delete from @thisround_classes;
	insert into @thisround_classes
	( 
		[id], [baseclass], [baseclass_namespace] 
	) 
	select [id], [baseclass], [baseclass_namespace] 
	from [dbo].[ParserClassInfo] 
	where 
		[classtype] = 'C' 
		and [id] not in ( select [id] from [dbo].[ParserClassHierarchy] )
end 

end 
