﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.SqlServer.TransactSql.ScriptDom;

namespace Parsing_T_SQL_Examples
{
    public static partial class Examples
    {
        public static int Example1(string tsqlcode)
        {
            TSqlScript sqlScript = null;

            //parse:
            {
                TSql110Parser parser;
                parser = new TSql110Parser(true);
                System.IO.StringReader txtRdr = new System.IO.StringReader(tsqlcode);

                IList<ParseError> errors;
                TSqlFragment sqlFragment = parser.Parse(txtRdr, out errors);

                sqlScript = (TSqlScript)sqlFragment;
                txtRdr.Dispose();
            }

            //look for Select * => SelectStarExpression class:
            SelectStarVisitor selectstarvisitor = new SelectStarVisitor();
            sqlScript.AcceptChildren(selectstarvisitor);

            return selectstarvisitor.SelectStarList.Count;
        }

        internal class SelectStarVisitor : TSqlConcreteFragmentVisitor
        {
            public List<SelectStarExpression> SelectStarList
            {
                get;
                internal set;
            }

            public SelectStarVisitor()
            {
                SelectStarList = new List<SelectStarExpression>();
            }

            public override void ExplicitVisit(SelectStarExpression node)
            {
                SelectStarList.Add(node);
            }
        }
    }
}
