﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.SqlServer.TransactSql.ScriptDom;

namespace Parsing_T_SQL_Examples
{
    public static partial class Examples
    {
        public static bool Example2(string tsqlcode)
        {
            TSqlScript sqlScript = null;

            //parse:
            {
                TSql110Parser parser;
                parser = new TSql110Parser(true);
                System.IO.StringReader txtRdr = new System.IO.StringReader(tsqlcode);

                IList<ParseError> errors;
                TSqlFragment sqlFragment = parser.Parse(txtRdr, out errors);

                sqlScript = (TSqlScript)sqlFragment;
                txtRdr.Dispose();
            }

            //look for Schema Objects => SchemaObjectName
            SchemaObjectNameVisitor schemaobjectnamevisitor = new SchemaObjectNameVisitor();

            foreach (TSqlBatch curbatch in sqlScript.Batches)
            {
                foreach (TSqlStatement curstatement in curbatch.Statements)
                {
                    if (curstatement is CreateViewStatement)
                    {
                        CreateViewStatement createviewstatement = (CreateViewStatement)curstatement;
                        createviewstatement.SelectStatement.AcceptChildren(schemaobjectnamevisitor);
                    }
                    else
                    {
                        curstatement.AcceptChildren(schemaobjectnamevisitor);
                    }
                }
            }

            foreach (SchemaObjectName schemaobject in schemaobjectnamevisitor.SchemaObjectNameList)
            {
                if (
                    schemaobject.DatabaseIdentifier == null
                    && schemaobject.SchemaIdentifier != null
                    )
                {
                    return false;
                }
            }

            return true;
        }

        internal class SchemaObjectNameVisitor : TSqlConcreteFragmentVisitor
        {
            public List<SchemaObjectName> SchemaObjectNameList
            {
                get;
                internal set;
            }

            public SchemaObjectNameVisitor()
            {
                SchemaObjectNameList = new List<SchemaObjectName>();
            }

            public override void ExplicitVisit(SchemaObjectName node)
            {
                SchemaObjectNameList.Add(node);
            }
        }
    }
}
