﻿USE [BLS_LAU_PolicyMap2]
GO

/****** Object:  View [dbo].[annual_geovalidated]    Script Date: 6/2/2014 2:44:53 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


CREATE view [dbo].[annual_geovalidated] 
as 
select 
	masterlist.geo_boundary_type_id, 
	masterlist.geo_boundary_identifier, 
	masterlist.geo_boundary_definition_id, 
	masterlist.time_frame 

	, datatab.laborforce 
	, datatab.employed 
	, datatab.unemplevel 
	, datatab.unemprate 
	, [PC1_laborforce]
	, [PC1_employed]
	, [PC1_unemplevel]
	, [CP1_unemprate]
	, [PC3_laborforce]
	, [PC3_employed]
	, [PC3_unemplevel]
	, [CP3_unemprate]
	, [PC5_laborforce]
	, [PC5_employed]
	, [PC5_unemplevel]
	, [CP5_unemprate]

from ( 
	select 
		B.geo_boundary_type_id, 
		B.geo_boundary_definition_id, 
		B.geo_boundary_identifier, 
		A.time_frame 
	from ( 
		select distinct time_frame 
		from [dbo].[annual_pctchange]
	) A cross join ( 
		select geo_boundary_type_id, geo_boundary_identifier, geo_boundary_definition_id 
		from [PolicyMap_GeoUniverse].[dbo].[Census2010_State_R2010]
		union all 
		select geo_boundary_type_id, geo_boundary_identifier, geo_boundary_definition_id 
		from [PolicyMap_GeoUniverse].[dbo].[Census2010_CBSA_R2010]
		union all 
		select geo_boundary_type_id, geo_boundary_identifier, geo_boundary_definition_id 
		from [PolicyMap_GeoUniverse].[dbo].[Census2010_County_R2010]
		union all 
		select geo_boundary_type_id, geo_boundary_identifier, geo_boundary_definition_id 
		from [PolicyMap_GeoUniverse].[dbo].[Census2010_MetroDivision_R2010]
		union all 
		select geo_boundary_type_id, geo_boundary_identifier, geo_boundary_definition_id 
		from [PolicyMap_GeoUniverse].[dbo].[Census2010_Place_R2010]
	) B 
) masterlist 
left outer join [dbo].[annual_pctchange] datatab 
on 
	masterlist.geo_boundary_type_id = datatab.geo_boundary_type_id 
	and masterlist.geo_boundary_identifier = datatab.geo_boundary_identifier 
	and masterlist.time_frame = datatab.time_frame 


GO


